;################### DRAW OUTLINES #######################
; 

;      //lmin <0,    
;      lminint:=Trunc(lmin+1); //first intersection (0..MAXLIGHT)
;      lmaxint:=Trunc(lmax+1); //last intersection + 1 (0..MAXLIGHT) //0    lminint=0
;      if(lminint > MAXLIGHT) then lminint:=MAXLIGHT;
;      if(lmaxint > MAXLIGHT) then lmaxint:=MAXLIGHT;
;      lminint:=max(lminint,MINLIGHT);
;      lmaxint:=max(lmaxint,MINLIGHT);
;      if (lminint=lmaxint)
;      then begin //intersections absent
;        lineforeor(x1, y1,
;                     x2, y2,
;                     lminint*COLINTERSECT);(**)
;      end
;      else begin //intersections present
;        //draw edge to lowest intersection
;          lineforeor(edge[i].intersect[lminint].xscr, edge[i].intersect[lminint].yscr,
;                     x1, y1,
;                     lminint*COLINTERSECT);{}
;        //draw edge to highest intersection
;          lineforeor(edge[i].intersect[lmaxint-1].xscr, edge[i].intersect[lmaxint-1].yscr,
;                     x2, y2,
;                     lmaxint*COLINTERSECT);{}
;        //draw edge between all intersections (lminint to lmaxint)
;        for j:=lminint+1 to lmaxint-1{because j-1 used} do //   ,  intersect[MAXLIGHT]  
;        begin
;            lineforeor(edge[i].intersect[j].xscr, edge[i].intersect[j].yscr,
;                       edge[i].intersect[j-1].xscr, edge[i].intersect[j-1].yscr,
;                       j*COLINTERSECT);
;        end;
;      end
	
drawoutlines
	ld hl,edge
	ld hy,NEDGE
findoutlines_loop
;hl=pointer to edge
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p1 (^TPoly)
	ld a,(de) ;p1.visible
	ld c,a
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p2 (^TPoly)
	ld a,(de) ;p2.visible
	xor c
	jp z,findoutlines_skip ;both polygons visible or invisible - not in outline

	push hl ;pointer to v1,v2,intersect

	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;de=v1 (^TVertex)
	ld a,(bc) ;x1 = v1.xscr
	ld e,a ;x1
	inc bc
	ld a,(bc) ;y1 = v1.yscr
	ld d,a ;y1
	inc bc
	ld a,(bc) ;l1 = v1.l
	ex af,af'

	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;de=v2 (^TVertex)

	ld (findoutlines_pintersect),hl ;pointer to intersect[0]
	push hl ;pointer to intersect[0]

	ld a,(bc) ;x2 = v2.xscr
	ld l,a ;x2
	inc bc
	ld a,(bc) ;y2 = v2.yscr
	ld h,a ;y2
	inc bc
	ld a,(bc) ;l2 = v2.l
;de=y1x1
;hl=y2x2

;l2>l1  ( x1<->x2, y1<->y2, l1<->l2)

;      if (l2<l1)
;      then begin
;        lt:=l1;l1:=l2;l2:=lt;
;        xt:=x1;x1:=x2;x2:=xt;
;        yt:=y1;y1:=y2;y2:=yt;
;      end;
	ld c,a ;l2
	ex af,af' ;l1
	cp c ;l2
	jr c,$+4 ;l1 < l2: skip
	 ex de,hl
	 ex af,af'

;a=lmin, a'=lmax
;de=y1x1, hl=y2x2
	ld c,a ;lmin
	ex af,af'
	ld b,a ;lmax

	;  0..255  0..MAXLIGHT
	;#60 -> 0
	;#70 -> 1
	;#80 -> 2
	;#90 -> 3
	;#a0 -> 4
;      lminint:=Trunc(lmin+1); //first intersection (0..MAXLIGHT)
;      if(lminint > MAXLIGHT) then lminint:=MAXLIGHT;
;      lminint:=max(lminint,MINLIGHT);
	ld a,c ;lmin
	sub MINLIGHTCODE-DLIGHTCODE
	jr nc,$+3
	 xor a
	rra
	rra
	rra
	rra
	and #0f
	cp MAXLIGHT
	jr c,$+4
	ld a,MAXLIGHT
	ld c,a ;lminint = first intersection
;      lmaxint:=Trunc(lmax+1); //last intersection + 1 (0..MAXLIGHT) //0    lminint=0
;      if(lmaxint > MAXLIGHT) then lmaxint:=MAXLIGHT;
;      lmaxint:=max(lmaxint,MINLIGHT-1);
	ld a,b ;lmax
	sub MINLIGHTCODE-DLIGHTCODE
	jr nc,$+3
	 xor a
	rra
	rra
	rra
	rra
	and #0f
	cp MAXLIGHT
	jr c,$+4
	ld a,MAXLIGHT
	ld b,a ;lmaxint = last intersection +1

;      if (lminint=lmaxint)
;      then begin //intersections absent
;        lineforeor(x1, y1,
;                     x2, y2,
;                     lminint*COLINTERSECT);(**)
;      end
;a=lmaxint
	cp c ;lmaxint=lminint?
	jr nz,findoutlines_intersections
	ld b,tcolor/256
	ld a,(bc)
	ld b,a
;hl=y1x1
;de=y2x2
;b=color
	call line ;  

	pop hl ;pointer to intersect[0]

	jp findoutlines_ok

findoutlines_intersections
;      else begin //intersections present
;        //draw edge to lowest intersection
;          lineforeor(edge[i].intersect[lminint].xscr, edge[i].intersect[lminint].yscr,
;                     x1, y1,
;                     lminint*COLINTERSECT);{}
;de=y1x1, hl=y2x2
;c=lminint
	ex (sp),hl ;pointer to intersect[0], keep y2x2
	push hl ;pointer to intersect[0]
	push bc ;b=lmaxint, c=lminint
	ld b,0
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
;c=lminint
	ld b,tcolor/256
	ld a,(bc)
	ld b,a
;hl=edge[i].intersect[lminint].xscr, edge[i].intersect[lminint].yscr
;de=y1x1
;b=color
;!!!  findintersection l==l2 ,     NULLintersection!!!
	call line

;        //draw edge to highest intersection
;          lineforeor(edge[i].intersect[lmaxint-1].xscr, edge[i].intersect[lmaxint-1].yscr,
;                     x2, y2,
;                     lmaxint*COLINTERSECT);{}
	pop bc ;b=lmaxint, c=lminint
	pop hl ;pointer to intersect[0]
	pop de ;y2x2
	push bc ;b=lmaxint, c=lminint
;de=y2x2
	ld c,b
	dec c
;c=lmaxint-1
	ld b,0
	add hl,bc
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	inc c
;c=lmaxint
	ld b,tcolor/256
	ld a,(bc)
	ld b,a
;hl=edge[i].intersect[lmaxint-1].xscr, edge[i].intersect[lmaxint-1].yscr
;de=y2x2
;b=color
;!!!  findintersection l==l2 ,     NULLintersection!!!
	call line

;        //draw edge between all intersections (lminint to lmaxint)
;        for j:=lminint+1 to lmaxint-1{because j-1 used} do //   ,  intersect[MAXLIGHT]  
;        begin
;            lineforeor(edge[i].intersect[j].xscr, edge[i].intersect[j].yscr,
;                       edge[i].intersect[j-1].xscr, edge[i].intersect[j-1].yscr,
;                       j*COLINTERSECT);
;        end;
;      end
	pop bc ;b=lmaxint, c=lminint
	dec b ;b=lmaxint-1
	 ld a,c ;j-1
	 cp b ;lmaxint-1
	 jp z,findoutlines_betweenok
findoutlines_betweenloop
;c=j-1
	push bc
	ld b,0
findoutlines_pintersect=$+1
	ld hl,0 ;pointer to intersect[0]
	add hl,bc
	add hl,bc
	;hl=pointer to intersect[j-1]
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	inc c
;c=j
	ld b,tcolor/256
	ld a,(bc)
	ld b,a
;hl=edge[i].intersect[j].xscr, edge[i].intersect[j].yscr
;de=edge[i].intersect[j-1].xscr, edge[i].intersect[j-1].yscr
;b=color
;!!!  findintersection l==l2 ,     NULLintersection!!!
	call line

	pop bc
	inc c
	ld a,c ;j-1
	cp b ;lmaxint-1
	jp nz,findoutlines_betweenloop
findoutlines_betweenok
findoutlines_ok	
	pop hl ;pointer to v1,v2,intersect
findoutlines_skip
;hl=pointer to v1,v2,intersect
	ld de,2*2+MAXLIGHT*2 ;skip v1,v2,intersect
	add hl,de
	dec hy
	jp nz,findoutlines_loop
	ret

	
;$$$$$$$$$$$$$$$$$$$$$$ DRAW INTERSECTS $$$$$$$$$$$$$$$$$$$$$$$$$

;    if poly[i].visible
;    then begin
;      e1:=edge[poly[i].e1];
;      e2:=edge[poly[i].e2];
;      e3:=edge[poly[i].e3];
;      for j:=0 to MAXLIGHT-1 do //   ,  intersect[MAXLIGHT]  
;      begin
;	  i1:=e1.intersect[j];
;	  i2:=e2.intersect[j];
;	  i3:=e3.intersect[j];
;	  if (i1.xscr<>NULLintersect)
;	  then begin //i1
;	    if (i2.xscr<>NULLintersect) //and i3.xscr=NULLintersect
;	    then drawintersect(i1,i2,j)
;	    else drawintersect(i1,i3,j); //i3.xscr<>NULLintersect
;	  end
;	  else begin //i2,i3 or no such level
;	    if (i2.xscr<>NULLintersect) //and i3.xscr<>NULLintersect
;	    then drawintersect(i2,i3,j);
;	  end;
;      end;
;    end;

;  TPoly = record
;    v1,v2,v3: integer; //^TVertex //  checkvisibility
; l:byte;
;    visible: boolean; //temporary
;    e1,e2,e3: integer; //^TEdge //  drawintersects,   intersect
;  end;

drawintersects
	ld hl,poly+(3*2) ;skip v1,v2,v3
	ld hy,NPOLY
drawintersects_loop
;hl=pointer to poly
	inc hl ;skip l

	ld a,(hl) ;visible
	or a
	jr z,drawintersects_skip ;insivible: skip

	push hl ;pointer to poly
	
	inc hl

	ld e,(hl)
	inc hl
	ld d,(hl)
	ld (drawintersects_e1),de ;de=e1 (^TEdge)
	inc hl

	ld e,(hl)
	inc hl
	ld d,(hl)
	ld (drawintersects_e2),de ;de=e2 (^TEdge)
	inc hl

	ld e,(hl)
	inc hl
	ld d,(hl)
	ld (drawintersects_e3),de ;de=e3 (^TEdge)
	;inc hl

;EDGEINTERSECTSHIFT=(2*2)+(2*2) ;skip p1,p2, v1,v2
	;ld bc,EDGEINTERSECTSHIFT
	ld bc,2*(MAXLIGHT-MINLIGHT-1) ;bc=j*2,   0 
drawintersects_poly

	push bc ;j*2 ; intersect = 2 bytes

drawintersects_e3=$+1
	ld hl,0 ;pointer to intersect[0]
	add hl,bc ;hl=pointer to intersect[j]
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de = i3 = e3.intersect[j]
	 push de ;i3
drawintersects_e2=$+1
	ld hl,0 ;pointer to intersect[0]
	add hl,bc ;hl=pointer to intersect[j]
	ld e,(hl)
	inc hl
	ld d,(hl)
	;de = i2 = e2.intersect[j]
drawintersects_e1=$+1
	ld hl,0 ;pointer to intersect[0]
	add hl,bc ;hl=pointer to intersect[j]
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;hl = i1 = e1.intersect[j]
	
	;ld a,l;(hl) ;i1.xscr
	 if NULLintersect
	 cp NULLintersect
	 else
	 or a
	 endif
	jr z,drawintersects23 ;i2,i3 or no such level
;i1
	ld a,e;(de) ;i2.scr
	 if NULLintersect
	 cp NULLintersect
	 else
	 or a
	 endif
	jr nz,drawintersects12
drawintersects13
;drawintersect(i1,i3,j)
	pop de ;i3  i2
	jp drawintersects123ok
drawintersects12
;drawintersect(i1,i2,j)
	 pop af ;skip i3
	jp drawintersects123ok
drawintersects23
;i2,i3 or no such level
	ld a,e;(de) ;i2.scr
	 if NULLintersect
	 cp NULLintersect
	 else
	 or a
	 endif
;drawintersect(i2,i3,j)
	 pop hl ;i3  i1
	jr z,drawintersects123q ;no such level
drawintersects123ok
;        lineforeor(i1(i3).xscr, i1(i3).yscr,
;                    i2(i3).xscr, i2(i3).yscr,
;                    ((light+1)*COLINTERSECT) xor ((light+0)*COLINTERSECT));
	ld a,c ;j*2
	rrca ;j
	;ld c,(hl) ;x1 = i1(i3).scrx
	;inc hl
	;ld b,(hl) ;y1 = i1(i3).scry
	;ex de,hl
	;ld e,(hl) ;x2 = i2(i3).scrx
	;inc hl
	;ld d,(hl) ;y2 = i2(i3).scry
	push hl
	ld h,tcolor/256
	ld l,a ;j
	 ;inc l
	ld a,(hl) ;color(j)
	inc l
	;dec l
	xor (hl) ;color(j+1) xor color(j)
	;ld h,b ;y1
	;ld l,c ;x1
	pop hl
	ld b,a
;hl=y1x1
;de=y2x2
;b=color
	call line
drawintersects123q

	pop bc ;j*2
	
	;ld a,c
	;add a,2 ; intersect = 2 bytes
	;ld c,a
	;cp EDGEINTERSECTSHIFT+(2*(MAXLIGHT-MINLIGHT))
	;jp nz,drawintersects_poly
	dec c
	dec c
	jp p,drawintersects_poly

	pop hl ;pointer to poly
	
drawintersects_skip
	ld de,1+(3*2)+(3*2) ;skip visible, e1,e2,e3, v1,v2,v3
	add hl,de
	dec hy
	jp nz,drawintersects_loop
	ret

;%%%%%%%%%%%%%%%%%%%%% FIND INTERSECTS %%%%%%%%%%%%%%%%%%%%%
	
;      x1:=vert[edge[i].v1].xscr;
;      y1:=vert[edge[i].v1].yscr;
;      l1:=vert[edge[i].v1].l;
;      x2:=vert[edge[i].v2].xscr;
;      y2:=vert[edge[i].v2].yscr;
;      l2:=vert[edge[i].v2].l;
;      if (l2<l1)
;      then begin
;        lt:=l1;l1:=l2;l2:=lt;
;        xt:=x1;x1:=x2;x2:=xt;
;        yt:=y1;y1:=y2;y2:=yt;
;      end;
;      for j:=0 to MAXLIGHT-1 do //   ,  intersect[MAXLIGHT]  
;      begin
;        l:=j;
;        if ((l>l1) and (l<l2))
;        then begin
;          lphase:=(l-l1)/(l2-l1);
;          edge[i].intersect[j].xscr:=Trunc(x1 + lphase*(x2-x1));
;          edge[i].intersect[j].yscr:=Trunc(y1 + lphase*(y2-y1));
;        end
;        else begin
;          edge[i].intersect[j].xscr:=NULLintersect;
;        end;
;      end;

;  TEdge = record
;    p1,p2: integer; //^TPoly;   visible
;    v1,v2: integer; //^TVertex (counted once from poly),   xscr,yscr,l
;    intersect: array[0..MAXLIGHT-1] of TIntersect; // 2  //   ,  intersect[MAXLIGHT]  
;  end;

;  TVertex = record
;    x,y,z: real;
;    xrot,yrot,zrot: real; //    rotate
;    xscr,yscr: integer;
;    l: real;
;  end;
findintersects
	ld hl,edge
	ld hy,NEDGE
findintersects_loop
;hl=pointer to edge
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p1 (^TPoly)
	ld a,(de)
	or a ;visible
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p2 (^TPoly)
	jr nz,findintersects_visible
	ld a,(de)
	or a
	jr z,findintersects_invisible ;both polygons invisible: skip
findintersects_visible	
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;bc=v1 (^TVertex)
	ld a,(bc) ;x1 = v1.xscr
	ld e,a ;x1
	inc bc
	ld a,(bc) ;y1 = v1.yscr
	ld d,a ;y1
	inc bc
	ld a,(bc) ;l1 = v1.l
	ex af,af'

	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;bc=v2 (^TVertex)

	push hl ;pointer to intersect[j]

	ld a,(bc) ;x2 = v2.xscr
	ld l,a ;x2
	inc bc
	ld a,(bc) ;y2 = v2.yscr
	ld h,a ;y2
	inc bc
	ld a,(bc) ;l2 = v2.l

; 4 :     x2-x1,     y2-y1
;l2>l1  ( x1<->x2, y1<->y2, l1<->l2)

;      if (l2<l1)
;      then begin
;        lt:=l1;l1:=l2;l2:=lt;
;        xt:=x1;x1:=x2;x2:=xt;
;        yt:=y1;y1:=y2;y2:=yt;
;      end;
	ld c,a ;l2
	ex af,af' ;l1
	cp c ;l2
	jr c,$+4 ;l1 < l2: skip
	 ex de,hl
	 ex af,af'

;a=l1, a'=l2
;de=y1x1, hl=y2x2
	ld (coeff_l1),a
	ld c,a
	ex af,af' ;l2
	sub c
	  ;jr c,$ ;l2>=l1
	ld (coeff_dl),a

;find log(l2-l1)
	ld c,a
	ld b,tlog/256
	ld a,(bc) ;log(l2-l1)
	ld (coeff_logdl),a

;find log(x2-x1)
; x2-x1 < 0,  :
;coeff_logdx=log(x1-x2)
;coeff_x1=x2
;patch coeff_addx=sub
;x = x1 + (lphase)*(x2-x1) = x2 + (1-lphase)*(x1-x2) = x1 - (lphase)*(x1-x2)
	ld a,e ;x1
	ld (coeff_x1),a
	 ld a,l ;x2
	cp e ;x1
	jr nc,$+4
	 ld l,e
	 ld e,a
	sbc a,a
	and #10
	add a,#86 ;#86=add a,(hl) ;#96=sub (hl)
	ld (coeff_addx),a
	ld a,l ;x2 (x1)
	sub e ;x1 (x2)
	ld c,a
	;ld b,tlog/256
	ld a,(bc) ;log(x2-x1)  log(x1-x2)
	ld (coeff_logdx),a

;find log(y2-y1)
; y2-y1 < 0,  :
;coeff_logdx=log(y1-y2)
;coeff_y1=y2
;patch coeff_addx=sub
;y = y1 + (lphase)*(y2-y1) = y2 + (1-lphase)*(y1-y2) = y1 - (lphase)*(y1-y2)
	ld a,d ;y1
	ld (coeff_y1),a
	 ld a,h ;y2
	sub d ;y1
	ld a,#86 ;add a,(hl)
	jr nc,$+5
	 ex de,hl
	 ld a,#96 ;sub (hl)
	ld (coeff_addy),a
	ld a,h ;y2 (y1)
	sub d ;y1 (y2)
	ld c,a
	;ld b,tlog/256
	ld a,(bc) ;log(y2-y1)  log(y1-y2)
	ld (coeff_logdy),a
	
	pop de ;pointer to intersect[j]

	call coeff ;    intersects
	ex de,hl
;hl=pointer to edge
	jp findintersects_ok
findintersects_invisible
	ld de,2*2+(MAXLIGHT*2) ;skip v1,v2,intersect
	add hl,de
findintersects_ok
	dec hy
	jp nz,findintersects_loop
	ret

;  intersects
; ,       ,         ,    
coeff
;lphase = (l-l1)/(l2-l1) = [0..1]  (0..1)?
;l,l1,l2=0..255 (  ,    )
;b=l ( )
;coeff_l1=l1  
;coeff_logdl=log(l2-l1) (  )  
;coeff_x1=x1  
;coeff_logdx=log(x2-x1) (  )  
;coeff_y1=y1  
;coeff_logdy=log(y2-y1) (  )  
;de=pointer to intersect[j],   pointer to edge[i] (     p1,p2,v1,v2,   x,y,l), ..  p1,p2,[v1,v2,   intersect]

;x = x1 + (lphase)*(x2-x1) = x1 - (lphase)*(x1-x2)
;y = y1 + (lphase)*(y2-y1) = y1 - (lphase)*(y1-y2)
	ld a,MINLIGHTCODE
	ld b,a ;l
coeff_loop
; intersect[j]
;j   ,     b=l
coeff_l1=$+1
	sub 0 ;l1
	jp c,coeff_skip ;l < l1: skip ( ,  )
coeff_dl=$+1
	cp 0 ;l2-l1
	  jr z,$+5 ;l = l2: don't skip ( -   drawoutlines)
	jp nc,coeff_skip ;l >= l2: skip ( ,  )
	;jp coeff_skip
	ld l,a ;l-l1
	 ld h,tlog/256
	ld a,(hl) ;log(l-l1)
coeff_logdl=$+1
	sub 0 ;log(l2-l1)
	  ;ld a,109 ;log(128)
	ld c,a ;log(lphase)
coeff_logdx=$+1
	add a,0 ;log(x2-x1)
	ld l,a ;log(lphase*(x2-x1))
	 ld h,2+(tlog/256) ;1+(texp/256)
coeff_x1=$+1
	ld a,0 ;x1
	  ;jr $+3
coeff_addx=$
	add a,(hl) ;add/sub lphase*(x2-x1) ;HSB(exp) -   ( LSB  ?)
	ld (de),a ;x = x1 + lphase*(x2-x1)
	 inc de
	ld a,c ;log(lphase)
coeff_logdy=$+1
	add a,0 ;log(y2-y1)
	ld l,a ;log(lphase*(y2-y1))
coeff_y1=$+1
	ld a,0 ;y1
	  ;jr $+3
coeff_addy=$
	add a,(hl) ;add/sub lphase*(y2-y1) ;HSB(exp) -   ( LSB  ?)
	ld (de),a ;y = y1 + lphase*(x2-x1) 
	 inc de
	ld a,b ;l
	add a,DLIGHTCODE
	ld b,a
	cp MAXLIGHTCODE
	jp nz,coeff_loop
	ret
coeff_skip
	 ld a,NULLintersect
	ld (de),a
	 inc de
	 inc de
	ld a,b ;l
	add a,DLIGHTCODE
	ld b,a
	cp MAXLIGHTCODE
	jp nz,coeff_loop
	ret

	
;???????????????????? draw edges (test) ????????????????????
;works ok

;  TEdge = record
;    p1,p2: integer; //^TPoly;   visible
;    v1,v2: integer; //^TVertex (counted once from poly),   xscr,yscr,l
;    intersect: array[0..MAXLIGHT-1] of TIntersect; // 2  //   ,  intersect[MAXLIGHT]  
;  end;

drawedges
	ld hl,edge
	ld hy,NEDGE
drawedges_loop
;hl=pointer to edge
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p1 (^TPoly)
	ld a,(de) ;p1.visible
	ld c,a
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl ;de=p2 (^TPoly)
	ld a,(de) ;p2.visible
	;xor c
	;jp z,drawedges_skip ;both polygons visible or invisible - not in outline
	or c
	jp z,drawedges_skip ;both polygons invisible - don't draw

	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;de=v1 (^TVertex)
	ld a,(bc) ;x1 = v1.xscr
	ld e,a ;x1
	inc bc
	ld a,(bc) ;y1 = v1.yscr
	ld d,a ;y1
	inc bc
	ld a,(bc) ;l1 = v1.l
	ex af,af'

	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl ;de=v2 (^TVertex)

	push hl ;pointer to intersect

	ld a,(bc) ;x2 = v2.xscr
	ld l,a ;x2
	inc bc
	ld a,(bc) ;y2 = v2.yscr
	ld h,a ;y2
	inc bc
	ld a,(bc) ;l2 = v2.l

	ld b,%01001000
	call line

	pop hl ;pointer to intersect

	ld de,MAXLIGHT*2 ;skip intersect
	add hl,de
	jp drawedges_ok
drawedges_skip
	ld de,2*2+(MAXLIGHT*2) ;skip v1,v2,intersect
	add hl,de
	jp drawedges_ok
drawedges_ok
	dec hy
	jp nz,drawedges_loop
	ret


